#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf microdc-0.11.0.tar.gz
    cd microdc-0.11.0
    bunzip2 -c ../microdc-0.11.0-symlinksafety-patch.bz2 | patch -p1 -b
    ./configure --prefix=/usr --sysconfdir=/etc --disable-nls
    make
    rm -f src/microdc
    # Wheezy: need to add -ltinfo (static).
    make -C src microdc READLINE_LIBS="-Wl,-Bstatic -lreadline -lncurses \
	    -Wl,-Bdynamic"
    strip -R .note -R .comment src/microdc
    cp src/microdc ../microdc/bin/
    cd ..
    rm -rf microdc-0.11.0
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
